import introExam.BinarySearchTree.BST;


/************************************************
These methods are the candidates for the BST question
*************************************************/


public class ExtendedBST extends BST {

   /**
   * Creates and returns an exact copy of the tree. This copy organizes
   * the same items and has the same structure. It does not duplicate the
   * reference data stored within each Node. Instead, it duplicate only 
   * the tree and the nodes it contains
   * <p>
   * This method does not change any of the items or the structure of the
   * original tree.
   * <p>
   * In the event of an error, it returns null.
   * <p>
   * @return an exact copy of the tree. This copy organizes
   * the same items and has the same structure.
   */
  public ExtendedBST cloneTree () {

    return null; // Remove this!
  }


  /**
   * Returns the level of the leaf that is closest to the top (root)
   * of the tree.
   * <p>
   * The root is considered to be at level 0.
   * <p>
   * This method does not change any of the items or the structure of the
   * original tree.
   * <p>
   * In the event of an error, it returns -1
   * <p>
   * <p>
   * @return the level of the leaf that is closest to the top (root)
   * of the tree.
   */
  public int minLeafLevel() {

    return -1; // Remove this!
  }


  /**
   * Returns the level of the leaf that is farthest from the top (root)
   * of the tree.
   * <p>
   * The root is considered to be at level 0.
   * <p>
   * This method does not change any of the items or the structure of the
   * original tree.
   * <p>
   * In the event of an error, it returns -1
   * <p>
   * <p>
   * @return the level of the leaf that is farthest from the top (root)
   * of the tree.
   */
  public int maxLeafLevel() {
  
    return -1; // Remove this!
  }


 /**
   * Returns true if, and only if, all leaves of the tree are at 
   * the same level (are the same distance from the root) and 
   * the tree has the maximum number of nodes for its depth 
   * (each node has exactly 0 or two children), and false otherwise.
   * <p>
   * This method does not change any of the items or the structure of the
   * original tree.
   * <p>
   * In the event of an error, it returns false
   * <p>
   * @return true if, and only if, all leaves of the tree are at
   * the same level (are the same distance from the root) and 
   * the tree has the maximum number of nodes for its depth 
   * (each node has exactly 0 or two children), and false otherwise.
   */
  public boolean isPerfect() {
  
    return false; // Remove this!
  }


  /**
   * Prints the value at each node between and including the root and 
   * the supplied keyValue. If keyValue is not present in the tree, 
   * nothing is printed.
   * <p>
   * This method does not change any of the items or the structure of the
   * original tree.
   * <p>
   * It can print the nodes in any order, but cannot use a collection
   *   class.
   */
  public void printPath (java.lang.Comparable keyValue) {

    return; // Remove this!
  }

  /**
   * Prints to the console a list of all items organized at the 
   * specified level of the tree.
   * If level greater than the height of the tree or no leaves at the 
   * given level, nothing is printed. For negative heights print nothing
   * <p>
   * This method does not change any of the items or the structure of the
   * original tree.
   * <p>
   * It can print all the nodes at the specified level
   */
  public void printLeavesAtLevel (int level){
 

    return; // Remove this!
  }


  /**
   * This method returns balanced factor of a given node with value
   * If the node does not exists, return -1
   * Balanced Factor is defined as the absolute value of the difference in heights between
   * left and right subtrees of the node.
   * <p>
   * This method does not change any of the items or the structure of the
   * original tree.
   * <p>
   * Print the absolute value of the differences between heights of left and
   * right subtrees. If the node does not exists, return -1 
   */
  public int balancedFactorOfNode (java.lang.Comparable value){
 

    return -1; // 
  }
  
 


}
